Added [ERROR]s and [INFO]s, removed unnecessary parenttmp directory check in bldpkg

Updated download URL in base/expat build filewhich was upgraded in previous commit
Converted all upper case variables to lower case in mksm
This commit is contained in:
SMLinux 2022-02-20 21:42:23 +05:30 committed by PktSurf
parent 0db4d069b0
commit b341d63e6a
3 changed files with 83 additions and 103 deletions

View file

@ -2,7 +2,7 @@ app=expat
version=2.4.5 version=2.4.5
build=1sml build=1sml
homepage='https://libexpat.github.io/' homepage='https://libexpat.github.io/'
download='https://github.com/libexpat/libexpat/releases/download/R_2_2_9/expat-2.2.9.tar.xz' download="https://github.com/libexpat/libexpat/archive/refs/tags/R_2_4_5.tar.gz"
desc="C library for parsing XML" desc="C library for parsing XML"
requires="musl" requires="musl"

58
bldpkg
View file

@ -24,14 +24,12 @@
# -> Sanitise build variables, add restrictions such as length of app name variable which should # -> Sanitise build variables, add restrictions such as length of app name variable which should
# only be in lower case and less than 50 characters, validate whether a string defined in homepage # only be in lower case and less than 50 characters, validate whether a string defined in homepage
# and download is indeed a valid url # and download is indeed a valid url
# -> Discard extraneous second parenttmp directory check
# -> Fix comments explaining how tmpfs is being validated # -> Fix comments explaining how tmpfs is being validated
# -> Add extra comments about how the build logic switches from tmpfs directory to non-tmpfs # -> Add extra comments about how the build logic switches from tmpfs directory to non-tmpfs
# directory if tmpfs directory validation fails # directory if tmpfs directory validation fails
# -> Uncomment entirety of the code where compilers are to be hard-validated and improve C code # -> Uncomment entirety of the code where compilers are to be hard-validated and improve C code
# in the test files and also add suitable bldpkg.conf switches for it # in the test files and also add suitable bldpkg.conf switches for it
# Add code to unset CFLAGS and CXXFLAGS when $arch is set to noarch # Add code to unset CFLAGS and CXXFLAGS when $arch is set to noarch
# Add [ERROR]s in post-install code
# Remove redundant distcc and ccache checks when preparing summary # Remove redundant distcc and ccache checks when preparing summary
# Begin subshell # Begin subshell
@ -94,14 +92,14 @@ elif [ -n "$1" ] ; then
if [ -f "$1" ] && [ "$extension" == "SMBuild" ] ; then if [ -f "$1" ] && [ "$extension" == "SMBuild" ] ; then
source "$1" source "$1"
else else
echo "Invalid file!" echo "[ERROR] Invalid file!"
exit 1 exit 1
fi fi
elif [ -z $1 ] && [ -f "$srcdirpath".SMBuild ]; then elif [ -z $1 ] && [ -f "$srcdirpath".SMBuild ]; then
source "$srcdirpath".SMBuild source "$srcdirpath".SMBuild
else else
echo "Please provide a build file as an argument" echo "[ERROR] Please provide a build file as an argument"
exit 1 exit 1
fi fi
@ -109,7 +107,7 @@ fi
# If any of the following variables are not set in the build file, abort. # If any of the following variables are not set in the build file, abort.
for buildvariables in app version build homepage desc requires ; do for buildvariables in app version build homepage desc requires ; do
if [[ ! "${!buildvariables}" ]] ; then if [[ ! "${!buildvariables}" ]] ; then
echo "Variable \"${buildvariables}\" is not set. Please check your build file. Aborting!" echo "[ERROR] Variable \"${buildvariables}\" is not set. Please check your build file. Aborting!"
exit 1 exit 1
fi fi
done done
@ -120,15 +118,15 @@ sleep 0.5
# Check if build() function exists in the build file # Check if build() function exists in the build file
if [[ ! "$(grep '^build()' "$srcdirpath".SMBuild)" ]] ; then if [[ ! "$(grep '^build()' "$srcdirpath".SMBuild)" ]] ; then
echo "build() function does not exist in your build file. Aborting!" echo "[ERROR] build() function does not exist in your build file. Aborting!"
exit 1 exit 1
fi fi
# Only verify source checksums if skipchecksum is not set in the build file # Only verify source checksums if skipchecksum is not set in the build file
if [ -z "$skipchecksum" ] ; then if [ -z "$skipchecksum" ] ; then
if [ -z "$sha512sums" ] ; then if [ -z "$sha512sums" ] ; then
echo "sha512 checksums don't exist in srcdirpath.SMBuild !" echo "[ERROR] sha512 checksums don't exist in "$srcdirpath".SMBuild !"
echo "Please run bldpkg genchecksum" echo "[ERROR] Please run 'bldpkg genchecksum' to add them"
exit 1 exit 1
fi fi
@ -149,7 +147,7 @@ fi
if [ -f /etc/bldpkg.conf ] ; then if [ -f /etc/bldpkg.conf ] ; then
source /etc/bldpkg.conf source /etc/bldpkg.conf
else else
echo "/etc/bldpkg.conf not found! Aborting!" echo "[ERROR] /etc/bldpkg.conf not found! Aborting!"
exit 1 exit 1
fi fi
@ -161,14 +159,14 @@ if [ "$checkdependencies" == "1" ] ; then
depcount="$(find /share/doc -name $packagedep.SMBuild | wc -l)" depcount="$(find /share/doc -name $packagedep.SMBuild | wc -l)"
# If count is 1, we are ok # If count is 1, we are ok
if [ "$depcount" == "1" ] ; then if [ "$depcount" == "1" ] ; then
echo "Found dependency $packagedep" echo "[INFO] Found dependency $packagedep"
# If count is 0, we exit, because we are in trouble # If count is 0, we exit, because we are in trouble
elif [ "$depcount" == "0" ] ; then elif [ "$depcount" == "0" ] ; then
echo "Did not find dependency $packagedep ! Aborting!" echo "[ERROR] Did not find dependency $packagedep ! Aborting!"
exit 1 exit 1
# If count is greater than or equal to 2, we are in slightly less trouble # If count is greater than or equal to 2, we are in slightly less trouble
elif [ "$depcount" -ge "2" ] ; then elif [ "$depcount" -ge "2" ] ; then
echo "Warning! Found multiple versions of $packagedep !" echo "[WARNING] Found multiple versions of $packagedep !"
sleep 0.5 sleep 0.5
fi fi
done done
@ -189,29 +187,26 @@ inarray() {
# Check if $parenttmp is set and is a directory # Check if $parenttmp is set and is a directory
if [ -z "$parenttmp" ] ; then if [ -z "$parenttmp" ] ; then
echo "parenttmp variable not set in /etc/bldpkg.conf. Aborting!" echo "[ERROR] parenttmp variable not set in /etc/bldpkg.conf. Aborting!"
exit 1 exit 1
elif [ ! -d "$parenttmp" ] ; then elif [ ! -d "$parenttmp" ] ; then
echo "parenttmp variable set to '"$tmpfsdir"' in /etc/bldpkg.conf is not a directory. Aborting!" echo "[ERROR] parenttmp variable set to '"$tmpfsdir"' in /etc/bldpkg.conf is not a directory. Aborting!"
exit 1 exit 1
fi fi
# Create the $parenttmp directory. This directory is used for everything related to the build process outside #the source directory $srcdir # Attempt to write to the $parenttmp directory. This directory is used for everything related to the build process outside #the source directory $srcdir
# First check if $parenttmp is a directory. If it does, check if it is writable. If not, create one. if ! touch "$parenttmp"/.smlinuxwritetest ; then
if [ -d "$parenttmp" ] ; then echo "[ERROR] $parenttmp is not writable. Aborting!"
if ! touch "$parenttmp"/.smlinuxwritetest ; then exit 1
echo "$parenttmp is not writable. Aborting!"
exit 1
fi
# Discard the test file
rm -f "$parenttmp"/.smlinuxwritetest
fi fi
# Discard the test file
rm -f "$parenttmp"/.smlinuxwritetest
# Determine if $tmpfsdir is listed inside $protecteddirectories array # Determine if $tmpfsdir is listed inside $protecteddirectories array
if inarray "${parenttmp}" "${protecteddirectories[@]}" ; then if inarray "${parenttmp}" "${protecteddirectories[@]}" ; then
echo "############ ATTENTION ############" echo "############ ATTENTION ############"
echo "parenttmp IS SET TO '"$tmpfsdir"' WHICH IS A PROTECTED DIRECTORY!! EXITING!!" echo "[ERROR] parenttmp IS SET TO '"$tmpfsdir"' WHICH IS A PROTECTED DIRECTORY!! EXITING!!"
exit 1 exit 1
fi fi
@ -769,24 +764,23 @@ mkfinalpkg() {
# Check if /lib64 was created inside $pkg # Check if /lib64 was created inside $pkg
if [ -d "$pkg/lib64" ] ; then if [ -d "$pkg/lib64" ] ; then
echo "$app has /lib64 directory. Musl does not support multilib." echo "[ERROR] $app has /lib64 directory. Musl does not support multilib."
echo "Please fix the build options and ensure the /lib64 is not created". echo "[ERROR] Please fix the build options and ensure the /lib64 is not created. Aborting! "
echo "Aborting."
exit 1 exit 1
fi fi
# Check if /usr and /sbin were created inside $pkg # Check if /usr and /sbin were created inside $pkg
for directory in usr sbin ; do for directory in usr sbin ; do
if [ -d "$pkg/$directory" ] ; then if [ -d "$pkg/$directory" ] ; then
echo "$app has $directory directory which is a symlink to /bin on SMLinux." echo "[ERROR] $app has $directory directory which is a symlink to /bin on SMLinux."
echo "Please fix the build options and ensure $directory is not created. Aborting!" echo "[ERROR] Please fix the build options and ensure $directory is not created. Aborting!"
exit 1 exit 1
fi fi
done done
if [ -d "$pkg/usr/var" ]; then if [ -d "$pkg/usr/var" ]; then
echo "$app has created an incorrect post-install /usr/var directory for storing logs and variable information." echo "[ERROR] $app has created an incorrect post-install /usr/var directory for storing logs and variable information."
echo "This stuff should go only inside /var. Kindly fix this. Aborting!" echo "[ERROR] This stuff should go only inside /var. Kindly fix this. Aborting!"
exit 1 exit 1
fi fi

126
mksm
View file

@ -1,31 +1,13 @@
#!/bin/bash #!/bin/bash
# Part of SMLinux distribution # Part of SMLinux distribution
# http://git.pktsurf.in/smlinux
# Package build file generator # Package build file generator
# Copyright (c) 2021-22 PktSurf <smlinux@pktsurf.in>
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
# Exit on any error
set -e set -e
# Date format # Date format
FILEDATE="$(date +%Y%m%d%H%M%S)" filedate="$(date +%Y%m%d%H%M%S)"
# Archive files # Archive files
ARCHIVEFILES=( *.tar.* *.zip *.t?z ) archivefiles=( *.tar.* *.zip *.t?z )
# Function to generate usage options # Function to generate usage options
mkusage() { mkusage() {
@ -64,36 +46,36 @@ fi
# Explanation same as above, but this time, if first argument is set then # Explanation same as above, but this time, if first argument is set then
# set use it as a value for $APPNAME variable # set use it as a value for $appname variable
if [ -n "$1" ] ; then if [ -n "$1" ] ; then
if [ "$1" = "-h" ] || [ "$1" = "-help" ] || [ "$1" = "--help" ] ; then if [ "$1" = "-h" ] || [ "$1" = "-help" ] || [ "$1" = "--help" ] ; then
mkusage mkusage
exit 0 exit 0
else else
APPNAME="$1" appname="$1"
fi fi
fi fi
# If/else to check if second argument is set. If it is, set it as a value # If/else to check if second argument is set. If it is, set it as a value
# for $VERSION variable. If it isn't, throw an error and exit. # for $version variable. If it isn't, throw an error and exit.
if [ -n "$2" ] ; then if [ -n "$2" ] ; then
VERSION="$2" version="$2"
else else
echo "Version not defined. Kindly define it. Exiting!" echo "Version not defined. Kindly define it. Exiting!"
exit 1 exit 1
fi fi
# If/else to check if third argument is set. If it is, set it as a value for # If/else to check if third argument is set. If it is, set it as a value for
# $BUILDSYS variable. If it isn't, throw an error and exit. # $buildsys variable. If it isn't, throw an error and exit.
if [ -n "$3" ] ; then if [ -n "$3" ] ; then
if [ "$3" = "make" ] ; then if [ "$3" = "make" ] ; then
BUILDSYS="make" buildsys="make"
elif [ "$3" = "autoconf" ] ; then elif [ "$3" = "autoconf" ] ; then
BUILDSYS="autoconf" buildsys="autoconf"
elif [ "$3" = "cmake" ] ; then elif [ "$3" = "cmake" ] ; then
BUILDSYS="cmake" buildsys="cmake"
elif [ "$3" = "meson" ] ; then elif [ "$3" = "meson" ] ; then
BUILDSYS="meson" buildsys="meson"
else else
echo "ERROR: Invalid build system. Aborting!" echo "ERROR: Invalid build system. Aborting!"
exit 1 exit 1
@ -103,78 +85,80 @@ else
exit 1 exit 1
fi fi
# If $APPNAME, $VERSION and $BUILDSYS variables are set, generate a build file. # If $appname, $version and $buildsys variables are set, generate a build file.
if [ -n "$APPNAME" ] && [ -n "$VERSION" ] && [ -n "$BUILDSYS" ] ; then if [ -n "$appname" ] && [ -n "$version" ] && [ -n "$buildsys" ] ; then
echo "Generating build file for application '"$APPNAME"' version '"$VERSION"' which uses build system '"$BUILDSYS"'..." echo "Generating build file for application '"$appname"' version '"$version"' which uses build system '"$buildsys"'..."
echo "" echo ""
echo "Current directory is $PWD" echo "Current directory is $PWD"
echo "" echo ""
# Copy the sample build file based on the build system argument passed # Copy the sample build file based on the build system argument passed
if [ -f "$APPNAME.SMBuild" ] ; then if [ -f "$appname.SMBuild" ] ; then
echo "Found an existing $APPNAME.SMBuild in the current directory." echo "Found an existing $appname.SMBuild in the current directory."
echo "Backing it up inside a directory 'old' and creating a new one here." echo "Backing it up inside a directory 'old' and creating a new one here."
mkdir -p old mkdir -p old
mv "$APPNAME.SMBuild" old/"$APPNAME.SMBuild.$FILEDATE" mv "$appname.SMBuild" old/"$appname.SMBuild.$filedate"
fi fi
# This one came in handy: # This one came in handy:
# https://unix.stackexchange.com/questions/505949/expanding-only-certain-variables-inside-a-heredoc # https://unix.stackexchange.com/questions/505949/expanding-only-certain-variables-inside-a-heredoc
# Expand variables in this heredoc # Expand variables in this heredoc
cat << EOF > $APPNAME.SMBuild cat << EOF > $appname.SMBuild
APP=$APPNAME app=$appname
VERSION=$VERSION version=$version
BUILD=1sml build=1sml
HOMEPAGE="" homepage=""
DOWNLOAD="" download=""
DESC="" desc=""
REQUIRES="musl" requires="musl"
EOF EOF
# Single-quoted 'EOF' prevents variables from being expanded in this heredoc # Single-quoted 'EOF' prevents variables from being expanded in this heredoc
cat << 'EOF' >> $APPNAME.SMBuild cat << 'EOF' >> $appname.SMBuild
build() { build() {
mkandenterbuilddir mkandenterbuilddir
rm -rf $APP-$VERSION rm -rf $app-$version
tar xf $SRCDIR/$APP-$VERSION.tar.?z* tar xf $srcdir/$app-$version.tar.?z*
cd $APP-$VERSION cd $app-$version
fixbuilddirpermissions fixbuilddirpermissions
EOF EOF
# Again prevent variables from being expanded in this heredoc # Again prevent variables from being expanded in this heredoc
gen_autoconf() { gen_autoconf() {
cat << 'EOF' >> $APPNAME.SMBuild cat << 'EOF' >> $appname.SMBuild
./configure \ ./configure \
--prefix="" \ --prefix="" \
--sysconfdir=/etc --sysconfdir=/etc
make make
make install DESTDIR=$PKG make install DESTDIR=$pkg
cp LICENSE $PKGDOCS/ cp LICENSE $pkgdocs/
mkfinalpkg mkfinalpkg
} }
EOF EOF
} }
gen_make() { gen_make() {
cat << 'EOF' >> $APPNAME.SMBuild cat << 'EOF' >> $appname.SMBuild
make make
make install DESTDIR=$PKG make install DESTDIR=$pkg
cp LICENSE $PKGDOCS/ cp LICENSE $pkgdocs/
mkfinalpkg mkfinalpkg
} }
EOF EOF
} }
# And again # And again
gen_cmake() { gen_cmake() {
cat << 'EOF' >> $APPNAME.SMBuild cat << 'EOF' >> $appname.SMBuild
mkdir smbuild && cd smbuild mkdir smbuild && cd smbuild
cmake .. \ cmake .. \
-DCMAKE_INSTALL_PREFIX="/" \ -DCMAKE_INSTALL_PREFIX="/" \
@ -183,40 +167,42 @@ EOF
-Wno-dev -Wno-dev
make make
make install DESTDIR=$PKG make install DESTDIR=$pkg
cp ../LICENSE $PKGDOCS/ cp ../LICENSE $pkgdocs/
mkfinalpkg mkfinalpkg
} }
EOF EOF
} }
# Again :) # Again :)
gen_meson() { gen_meson() {
cat << 'EOF' >> $APPNAME.SMBuild cat << 'EOF' >> $appname.SMBuild
mkdir smbuild && cd smbuild mkdir smbuild && cd smbuild
meson .. \ meson .. \
--prefix="/" --prefix="/"
ninja ninja
DESTDIR="$PKG" ninja install DESTDIR="$pkg" ninja install
cp ../LICENSE $PKGDOCS/ cp ../LICENSE $pkgdocs/
mkfinalpkg mkfinalpkg
} }
EOF EOF
} }
case "$BUILDSYS" in case "$buildsys" in
autoconf) gen_autoconf ;; autoconf) gen_autoconf ;;
make) gen_make ;; make) gen_make ;;
cmake) gen_cmake ;; cmake) gen_cmake ;;
meson) gen_meson ;; meson) gen_meson ;;
esac esac
chmod +x $APPNAME.SMBuild chmod +x $appname.SMBuild
echo "...done" echo "...done"
echo "" echo ""
@ -224,21 +210,21 @@ fi
# Generate sha512sums in the build file # Generate sha512sums in the build file
echo "Adding new SHA512SUMS in $APPNAME.SMBuild..." echo "Adding new sha512sums in $appname.SMBuild..."
printf '\n' >> "$APPNAME".SMBuild printf '\n' >> "$appname".SMBuild
printf 'SHA512SUMS="\n' >> "$APPNAME".SMBuild printf 'sha512sums="\n' >> "$appname".SMBuild
# File types # File types
FILES=( *.tar.* *.zip *.t?z *.patch *.diff *.c *.h ) files=( *.tar.* *.zip *.t?z *.patch *.diff *.c *.h )
# Checksum digest to be used along with arguments # Checksum digest to be used along with arguments
CHECKSUMBINARY="sha512sum" checksumbinary="sha512sum"
for FILE in ${FILES[@]} ; do for file in ${files[@]} ; do
if [ -f "$FILE" ] ; then if [ -f "$file" ] ; then
$CHECKSUMBINARY $FILE >> "$APPNAME".SMBuild $checksumbinary $file >> "$appname".SMBuild
fi fi
done done
printf '"' >> "$APPNAME".SMBuild printf '"' >> "$appname".SMBuild
exit 0 exit 0